import * as i0 from '@angular/core';
import { Component, Injectable, EventEmitter, Input, Output, NgModule } from '@angular/core';
import * as i1 from '@ionic/angular';
import { IonicModule } from '@ionic/angular';
import { Subject } from 'rxjs';
import * as i2 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

class CustomBtnComponent {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: CustomBtnComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.5", type: CustomBtnComponent, isStandalone: false, selector: "ngx-custom-btn", ngImport: i0, template: "<ion-button>Sandhiya</ion-button>", styles: [""], dependencies: [{ kind: "component", type: i1.IonButton, selector: "ion-button", inputs: ["buttonType", "color", "disabled", "download", "expand", "fill", "form", "href", "mode", "rel", "routerAnimation", "routerDirection", "shape", "size", "strong", "target", "type"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: CustomBtnComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-custom-btn', standalone: false, template: "<ion-button>Sandhiya</ion-button>" }]
        }] });

class TestOtpService {
    constructor() { }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
    static ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpService, providedIn: 'root' });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

class TestOtpComponent {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.5", type: TestOtpComponent, isStandalone: false, selector: "ngx-test-otp", ngImport: i0, template: `
    <p>
      test-otp works!
    </p>
  `, isInline: true, styles: [""] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-test-otp', template: `
    <p>
      test-otp works!
    </p>
  `, standalone: false }]
        }] });

class OtpComponent {
    OTP = {
        first: '',
        second: '',
        third: '',
        four: '',
        five: '',
        six: '',
    };
    clear = false;
    otpValues = new EventEmitter();
    otpSub;
    clearOTP = new Subject();
    ngOnInit() {
        this.otpSub = this.clearOTP.subscribe((value) => {
            if (value) {
                this.resetOTP();
            }
        });
    }
    ngOnChanges(changes) {
        console.log("hello", changes);
        if (changes["clear"].currentValue) {
            this.OTP = {
                first: '',
                second: '',
                third: '',
                four: '',
                five: '',
                six: '',
            };
        }
        console.log(this.OTP);
    }
    ngOnDestroy() {
        if (this.otpSub) {
            this.otpSub.unsubscribe();
        }
    }
    resetOTP() {
        this.OTP = {
            first: '',
            second: '',
            third: '',
            four: '',
            five: '',
            six: '',
        };
    }
    otpController(event, next, prev, index) {
        setTimeout(() => {
            if (event.target.value.length < 1 && prev) {
                prev.setFocus();
            }
            else if (next && event.target.value.length > 0) {
                next.setFocus();
            }
        }, 0);
    }
    verifyOtp() {
        if (Object.values(this.OTP).every((val) => val != '')) {
            console.log('submit');
            this.otpValues.emit(this.OTP);
        }
        else {
            this.otpValues.emit('');
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: OtpComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.1.5", type: OtpComponent, isStandalone: false, selector: "ngx-otp", inputs: { clear: "clear" }, outputs: { otpValues: "otpValues" }, usesOnChanges: true, ngImport: i0, template: "\r\n\r\n  <p class=\"mt-0\">Please enter the OTP here.</p>\r\n  <ion-row class=\"otpRow\">\r\n    <ion-col class=\"otpdiv\">\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp1\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.first\"\r\n        (keyup)=\"otpController($event, otp2, '')\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp2\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.second\"\r\n        (keyup)=\"otpController($event, otp3, otp1)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp3\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.third\"\r\n        (keyup)=\"otpController($event, otp4, otp2)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp4\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.four\"\r\n        (keyup)=\"otpController($event, otp5, otp3)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp5\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.five\"\r\n        (keyup)=\"otpController($event, otp6, otp4)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp6\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.six\"\r\n        (keyup)=\"otpController($event, '', otp5, 6)\"\r\n      ></ion-input>\r\n    </ion-col>\r\n  </ion-row>\r\n   <div>\r\n    <ion-button class=\"clickBtn\"\r\n    shape=\"round\"\r\n    fill=\"outline\" (click)=\"verifyOtp()\">OTP Verify</ion-button>\r\n  </div> \r\n ", styles: [".otpdiv{margin:0 auto;text-align:center}.x{display:inline-block;width:40px;height:40px;margin:5px;padding-left:5px;border:1px solid #229e827d;box-shadow:0 3px 12px #229e824d;color:#000;border-radius:5px}.btnHead{margin-top:30px;display:flex;justify-content:center}.clickBtn{height:30px;font-family:Poppins-medium;width:auto;padding:0 15px;background-color:var(--UJ-color-background);display:flex;align-items:center;justify-content:center;border-radius:15px}.clickBtn{height:30px;font-family:Poppins-medium;--border-color: var(--UJ-color-primary);--color: black;width:130px}\n"], dependencies: [{ kind: "component", type: i1.IonButton, selector: "ion-button", inputs: ["buttonType", "color", "disabled", "download", "expand", "fill", "form", "href", "mode", "rel", "routerAnimation", "routerDirection", "shape", "size", "strong", "target", "type"] }, { kind: "component", type: i1.IonCol, selector: "ion-col", inputs: ["offset", "offsetLg", "offsetMd", "offsetSm", "offsetXl", "offsetXs", "pull", "pullLg", "pullMd", "pullSm", "pullXl", "pullXs", "push", "pushLg", "pushMd", "pushSm", "pushXl", "pushXs", "size", "sizeLg", "sizeMd", "sizeSm", "sizeXl", "sizeXs"] }, { kind: "component", type: i1.IonInput, selector: "ion-input", inputs: ["autocapitalize", "autocomplete", "autocorrect", "autofocus", "clearInput", "clearInputIcon", "clearOnEdit", "color", "counter", "counterFormatter", "debounce", "disabled", "enterkeyhint", "errorText", "fill", "helperText", "inputmode", "label", "labelPlacement", "max", "maxlength", "min", "minlength", "mode", "multiple", "name", "pattern", "placeholder", "readonly", "required", "shape", "spellcheck", "step", "type", "value"] }, { kind: "component", type: i1.IonRow, selector: "ion-row" }, { kind: "directive", type: i1.TextValueAccessor, selector: "ion-input:not([type=number]),ion-textarea,ion-searchbar" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: OtpComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-otp', standalone: false, template: "\r\n\r\n  <p class=\"mt-0\">Please enter the OTP here.</p>\r\n  <ion-row class=\"otpRow\">\r\n    <ion-col class=\"otpdiv\">\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp1\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.first\"\r\n        (keyup)=\"otpController($event, otp2, '')\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp2\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.second\"\r\n        (keyup)=\"otpController($event, otp3, otp1)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp3\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.third\"\r\n        (keyup)=\"otpController($event, otp4, otp2)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp4\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.four\"\r\n        (keyup)=\"otpController($event, otp5, otp3)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp5\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.five\"\r\n        (keyup)=\"otpController($event, otp6, otp4)\"\r\n      ></ion-input>\r\n      <ion-input\r\n        class=\"x\"\r\n        numberonly\r\n        type=\"tel\"\r\n        #otp6\r\n        maxLength=\"1\"\r\n        [(ngModel)]=\"OTP.six\"\r\n        (keyup)=\"otpController($event, '', otp5, 6)\"\r\n      ></ion-input>\r\n    </ion-col>\r\n  </ion-row>\r\n   <div>\r\n    <ion-button class=\"clickBtn\"\r\n    shape=\"round\"\r\n    fill=\"outline\" (click)=\"verifyOtp()\">OTP Verify</ion-button>\r\n  </div> \r\n ", styles: [".otpdiv{margin:0 auto;text-align:center}.x{display:inline-block;width:40px;height:40px;margin:5px;padding-left:5px;border:1px solid #229e827d;box-shadow:0 3px 12px #229e824d;color:#000;border-radius:5px}.btnHead{margin-top:30px;display:flex;justify-content:center}.clickBtn{height:30px;font-family:Poppins-medium;width:auto;padding:0 15px;background-color:var(--UJ-color-background);display:flex;align-items:center;justify-content:center;border-radius:15px}.clickBtn{height:30px;font-family:Poppins-medium;--border-color: var(--UJ-color-primary);--color: black;width:130px}\n"] }]
        }], propDecorators: { clear: [{
                type: Input
            }], otpValues: [{
                type: Output
            }] } });

class TestOtpModule {
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
    static ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.1.5", ngImport: i0, type: TestOtpModule, declarations: [TestOtpComponent,
            CustomBtnComponent,
            OtpComponent], imports: [IonicModule,
            CommonModule,
            FormsModule], exports: [CustomBtnComponent,
            TestOtpComponent,
            OtpComponent] });
    static ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpModule, imports: [IonicModule,
            CommonModule,
            FormsModule] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.1.5", ngImport: i0, type: TestOtpModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        TestOtpComponent,
                        CustomBtnComponent,
                        OtpComponent
                    ],
                    imports: [
                        IonicModule,
                        CommonModule,
                        FormsModule
                    ],
                    exports: [
                        CustomBtnComponent,
                        TestOtpComponent,
                        OtpComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of test-otp
 */
// comitting on otp-component branchz

/**
 * Generated bundle index. Do not edit.
 */

export { CustomBtnComponent, OtpComponent, TestOtpComponent, TestOtpModule, TestOtpService };
//# sourceMappingURL=test-otp.mjs.map
